LeetCode 739. 每日温度
题目链接:https://leetcode.cn/problems/daily-temperatures/description/
文章链接:https://programmercarl.com/0739.%E6%AF%8F%E6%97%A5%E6%B8%A9%E5%BA%A6.html
思路
* 单调栈的本质是空间换时间,因为在遍历的过程中需要用一个栈来记录右边第一个比当前元素高的元素,优点是整个数组只需要遍历一次。* 单调栈里只需要存放元素的下标i就可以了,如果需要使用对应的元素,直接T[i]就可以获取。* 单调栈的本质其实是记录遍历过的元素,单调栈的顺序由栈顶到栈底是单调递增的* 当我们遍历的元素大于栈顶元素的时候,因为栈顶元素一定存放的是栈中最大的元素,则当前元素一定是第一个比栈顶元素大的元素。* 当我们遍历的元素小于等于栈顶元素的时候,当前元素入栈
public int[] dailyTemperatures(int[] temperatures) {Stack<Integer> stack = new Stack<>();int[] res = new int[temperatures.length];stack.push(0);for (int i = 1; i < temperatures.length; i++) {if (temperatures[i] <= temperatures[stack.peek()]){stack.push(i);}else {while (!stack.isEmpty() && temperatures[i] > temperatures[stack.peek()]){res[stack.peek()] = i - stack.peek();stack.pop();}stack.push(i);}}return res;}
LeetCode 496.下一个更大元素 I
题目链接:https://leetcode.cn/problems/next-greater-element-i/description/
文章链接:https://programmercarl.com/0496.%E4%B8%8B%E4%B8%80%E4%B8%AA%E6%9B%B4%E5%A4%A7%E5%85%83%E7%B4%A0I.html#%E7%AE%97%E6%B3%95%E5%85%AC%E5%BC%80%E8%AF%BE
思路
本题思路同每日温度一样,都是利用单调栈来解体,唯一不同的是需要对Num1数组做一个映射。
public int[] nextGreaterElement(int[] nums1, int[] nums2) {Stack<Integer> stack = new Stack<>();HashMap<Integer, Integer> map = new HashMap<>();for (int i = 0; i < nums1.length; i++) {map.put(nums1[1], i);}stack.push(0);int[] res = new int[nums2.length];Arrays.fill(res, -1);for (int i = 1; i < nums2.length; i++) {if (nums2[i] <= nums2[stack.peek()]){stack.push(i);}else {while (!stack.isEmpty() && nums2[i] > nums2[stack.peek()]){res[map.get(stack.peek())] = i - stack.peek();stack.pop();}stack.push(i);}}return res;}
LeetCode 503.下一个更大元素II
题目链接:https://leetcode.cn/problems/next-greater-element-ii/description/
文章链接:https://programmercarl.com/0503.%E4%B8%8B%E4%B8%80%E4%B8%AA%E6%9B%B4%E5%A4%A7%E5%85%83%E7%B4%A0II.html#%E7%AE%97%E6%B3%95%E5%85%AC%E5%BC%80%E8%AF%BE
思路
本题思路同每日温度一样,都是利用单调栈来解体,不过数组是一个首尾相连的数组,我们只需要将两个数组拼接即可
public int[] nextGreaterElements(int[] nums) {//边界判断if(nums == null || nums.length <= 1) {return new int[]{-1};}int size = nums.length;int[] result = new int[size];//存放结果Arrays.fill(result,-1);//默认全部初始化为-1Stack<Integer> st= new Stack<>();//栈中存放的是nums中的元素下标for(int i = 0; i < 2*size; i++) {while(!st.empty() && nums[i % size] > nums[st.peek()]) {result[st.peek()] = nums[i % size];//更新resultst.pop();//弹出栈顶}st.push(i % size);}return result;}